// For...of will give us the items instead of the indexes.
for (var item of [2,4,6,8])
    console.log(item);

var cart =
{
    items: ["pizza", "car", "pastrami"],
    [Symbol.iterator] : function ()
    {
        var index = 0;
        var length = this.items.length;

        return  {
                    next: () =>
                    {
                        if (index < length)
                            return { value: this.items[index++], done: false };
                        
                        return { value:null, done: true };
                    }
               }
    }
}

for (item of cart)
    console.log(item + " is in your cart!");;

var cart =
{
    items: ["pizza", "car", "pastrami"],
    [Symbol.iterator] : function* ()
    {
        for (var index = 0; index < this.items.length; ++index)
            yield this.items[index];
    }
}

for (item of cart)
    console.log(item + " is in your cart!");;
